 import java.io.*;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.Scanner;
import java.net.*;
 
 
 
public class TCPServer {
	

	public static void main( String argv[] ) throws Exception {
		int v = 0;
		LinkedList<LogEntry> log = new LinkedList<LogEntry>();
		
		
		ServerSocket welcomeSocket = new ServerSocket( 6789 );
		System.out.println( "Server startet" );
		
		while( true ) {
			Socket connectionSocket = welcomeSocket.accept();
			
			BufferedReader inFromClient =  
					new BufferedReader( new InputStreamReader( connectionSocket.getInputStream() ));
			
			
			// get type
			int type = 0;
			StringBuffer out = new StringBuffer();
			String input  = inFromClient.readLine();
			Scanner parse = new Scanner( input );
			parse.useDelimiter(" ");
			try {
				type = parse.nextInt();
			}
			catch( NumberFormatException e ) {
				// error
			}
			
			switch( type ) {
				case( 1 ): //query
				// 	get term
					log.add( new LogEntry( v, "Queried v", connectionSocket.getInetAddress() ));
					out.append("Value of V: " + v );
				
				break;
				case( 2 ):
					// edit
					if( parse.hasNext() ) {
						
					int term = parse.nextInt();
					v+= term;
					log.add( new LogEntry( v, "Edited v: " + term, connectionSocket.getInetAddress() ));
					out.append("Edited");
					}
					else
						out.append( "Error: Not edited!" );
						
				break;
				
				case( 3 ): // list
					
					log.add(new LogEntry( v, "Aquired log", connectionSocket.getInetAddress()));
					
					Iterator<LogEntry> it = log.iterator();
					while( it.hasNext() ) {
						out.append(it.next() );	
						out.append( '\n' );
					}
				
					
			break;
			
			default:
				out.append("Error: Invalid request");
			}
				
			

			DataOutputStream outToClient = 
				new DataOutputStream( connectionSocket.getOutputStream() );
			System.out.println( out );
			outToClient.writeBytes( out.toString() + '\n');
			
			
		}
		
	}
			
	
	
	
}
